// Camera.h: interface for the CCamera class.
//
//////////////////////////////////////////////////////////////////////

//#include "vector.h"
#include "includes.h"

#if !defined(AFX_CAMERA_H__B79DB31B_CE6C_4515_98FA_CCE634E528E8__INCLUDED_)
#define AFX_CAMERA_H__B79DB31B_CE6C_4515_98FA_CCE634E528E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

CVector RotatePoint(CVector p, CVector o_angle);


class CCamera  
{


public:
	CVector Position;
	CVector LookAt;
	CVector Angle;

	float Wide;
	float DisNear, DisFar;
	BOOL bLookAt;

	CCamera();
	virtual ~CCamera();

//	void View();
	void SetLookAt(CVector);
	void SetPosition(CVector new_pos);
	void SetOrientation(CVector new_angle);
	void SetWide(float new_wide);
	void SetDistanse(float new_near, float new_far);
	void Move(float speed);
	void RotateX(float speed);
	void RotateY(float speed);


};

#endif // !defined(AFX_CAMERA_H__B79DB31B_CE6C_4515_98FA_CCE634E528E8__INCLUDED_)
