unit g_clump;

interface
uses
  HGE,HGEFont,HGESprite,HGEParticle, HGEVector, HGEMatrix, HGEPhysics,
  g_Types,g_cfg,math;

type
  TClump = class
  public
    tex : ITexture;
    spr : IHGESprite;

    bTurnLeft, bTurnRight, bForward, bBackward : boolean;
  public
    constructor create;
    procedure Init;
    procedure Update(dt:single);
    procedure Render;
    procedure turnLeft;
    procedure turnRight;
    procedure pressGas;
    procedure pressBreak;
  end;


var
  Clump : TClump;

implementation

constructor TClump.create;
begin
  inherited;
  Tex := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\clump.cfg','TEXTURE_CLUMP','clump.png'));
  Spr := THGESprite.Create(Tex,0,0,Tex.GetWidth,Tex.GetHeight);
  Spr.SetHotSpot(Tex.GetWidth / 2,Tex.GetHeight / 2);
  Spr.SetColor($ffffffff);
end;


procedure TClump.Init;
begin
  bTurnLeft := false;
  bTurnRight := false;
  bForward := false;
  bBackward := false;
end;

procedure TClump.update(dt:single);
begin
if (bForward)
then begin // 
//
end;

if (bBackward)
then begin
//
end;


if (bTurnRight)
then begin	//  
//
end
else
if (bTurnLeft)
then begin	//  
//
end;

//  
bTurnLeft := false;
bTurnRight := false;
bForward := false;
bBackward := false;
end;

procedure TClump.turnLeft;
begin
  bTurnLeft := true;
end;

procedure TClump.turnRight;
begin
bTurnRight := true;
end;

procedure TClump.pressGas;
begin
bForward := true;
end;

procedure TClump.pressBreak;
begin
bBackward := true;
end;

procedure TClump.Render;
begin
  Spr.RenderEx(100,100,0*180.0/pi,1);
end;

end.
