unit g_gun;

interface
uses
  Classes,
  HGE,HGESprite,HGEParticle,
  g_Types,g_math,g_cfg,g_map,g_gui,g_Bullet_Manager;

type
  TGun = class
    X,Y : single;
    inShot : boolean;
    FireDemage : single;                                                       //  
    ReloadTime : single;                                                       //  
    ReloadDelay : single;                                                      //   
    Damage_Time  : single;
    Damage_Delay : single;
    Fire : boolean;
    Tex : ITexture;
    Spr : IHGESprite;
    TexParticle : ITexture;
    MaxLevel,level : byte;
    constructor Create;                                                         virtual;
    destructor destroy;                                                         virtual;
    procedure Init;                                                             virtual;
    procedure Shot;                                                             virtual;
    procedure Update(const delta : single;const _X,_Y : single);                virtual;
    procedure Render;                                                           virtual;
  end;

implementation

constructor TGun.Create;
begin
  inherited;
  //
end;

destructor TGun.destroy;
begin

  inherited;
end;

procedure TGun.Init;
begin
  inShot := false;
  level := 1;
  MaxLevel := 6;
end;

procedure TGun.Shot;
begin
  {case level of
    1 : BulletMan.AddBullet(btMini,X,Y);
    2 : begin
      BulletMan.AddBullet(btMini,X-20,Y);
      BulletMan.AddBullet(btMini,X+20,Y);
    end;
    3 : begin
      BulletMan.AddBullet(btMini,X,Y);
      BulletMan.AddBullet(btMini,X-20,Y);
      BulletMan.AddBullet(btMini,X+20,Y);
    end;
    4 : begin
      BulletMan.AddBullet(btMini,X,Y);
      BulletMan.AddBullet(btMini,X-20,Y);
      BulletMan.AddBullet(btMini,X+20,Y);
      BulletMan.AddBullet(btRocket,X-50,Y);
      BulletMan.AddBullet(btRocket,X+50,Y);
    end;
  end; }
end;

procedure TGun.Update(const delta : single;const _X,_Y : single);
begin
  X := _X;
  Y := _Y;
  ReloadTime := ReloadTime + delta;
  if (inShot)and(ReloadTime > ReloadDelay) then begin
    Shot;
    inShot := false;
    ReloadTime := 0;
  end else inShot := false;
end;

procedure TGun.Render;
begin

end;

end.
