unit g_language;

interface
uses
  g_Options,g_cfg,g_utils;

type
  TLanguageType = (ltRussian,ltEnglish);
  TLanguageMenu = class
    Continue,Play,Options,TOP,Credits,Exit : string;
  end;
  TLanguage = class
    _Type : TLanguageType;
    Menu : TLanguageMenu;
    Player : array [1..8] of string;
    constructor Create;
  end;

var
  Language : TLanguage;

implementation

constructor TLanguage.Create;
var
  i: Integer;
begin
  inherited;
  Menu := TLanguageMenu.Create;
  Menu.Continue := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','MENU_CONTINUE','nul');
  Menu.Play := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','MENU_NEW_GAME','nul');
  Menu.Options := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','MENU_OPTIONS','nul');
  Menu.Credits := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','MENU_CREDITS','nul');
  Menu.TOP := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','MENU_TOP','nul');
  Menu.Exit := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','MENU_EXIT','nul');
  for i := 1 to 8 do
    Player[i] := Cfg_ReadStr('data\cfg\text_'+Options.Language+'.cfg','PLAYER_NAME_'+inttostr(i),'nul');
end;

end.
