//=============================================================================
//           : Half-Light
//   : e_pchar.pas
//        :   
//            : Den (   Soulghai')
//    : 29.10.2007
//       :
//
//
//=============================================================================
unit g_pchar;

interface
uses
  Windows,
  g_Utils;

//function GetPCharLength(const Src: PChar): integer;
function StrLen(const Str: PChar): Cardinal; assembler;
procedure SetPCharText(var Dst: PChar; const Src: PChar; const Pos: integer);
procedure AddPCharText(var Dst: PChar; const Src: PChar; const Pos: integer);
procedure SetPChar(var Dst: PChar; const Src: PChar);
implementation

{function GetPCharLength(const Src: PChar): integer;
begin
  Result := 0;
  if Src <> nil then begin
    while Src[Result] <> #0 do Result := Result + 1;
  end;
end; }

function StrLen(const Str: PChar): Cardinal; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        MOV     EAX,0FFFFFFFEH
        SUB     EAX,ECX
        MOV     EDI,EDX
end;

procedure SetPCharText(var Dst: PChar; const Src: PChar; const Pos: integer);
begin
  Inc(Dst, Pos);
  Dst^ := Src^;
  Dec(Dst, Pos);
end;

procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;

procedure AddPCharText(var Dst: PChar; const Src: PChar; const Pos: integer);
var
  InitStr, SubStr: PChar;
  Len, DstLen, SrcLen: integer;
begin
  SetPChar(InitStr, Dst);
  SetPChar(SubStr, Src);
  StrDispose(Dst);
  DstLen := StrLen(InitStr);
  SrcLen := StrLen(SubStr);
  Len := DstLen + SrcLen;
  Dst := StrAlloc(Len);
  StrCopy(Dst, InitStr);
  Inc(Dst, Pos);
  Inc(InitStr, Pos);
  StrCopy(Dst, SubStr);
  Inc(Dst, SrcLen);
  StrCopy(Dst, InitStr);
  Dec(Dst, Pos + SrcLen);
  Dec(InitStr, Pos);
end;

procedure SetPChar(var Dst: PChar; const Src: PChar);
begin
  Dst := StrAlloc(StrLen(Src)+1);
  StrCopy(Dst, Src);
end;

end.
