unit Live;

//   
// !!!!!!!
//          
//  , ..      
//   ,     
// .  ,    ,    

interface
uses
  BR_map, BR_game, BR_ai, S_Dura, LexUtils;

const
  gravity = 8;
  
var                      
  kX, kY : word;

procedure Move(pX, pY : shortint; T : TTPers; var P : Tpers; var P2 : TPersP2);
function  KlNoClip(kkX, kkY : byte) : boolean;

implementation

function KlNoClip(kkX, kkY : byte) : boolean; // ,   
begin
  if  (Map.Kl[kkX, kkY].T in [clip, clip2])  //  
  then
  result:=false
  else
  result:=true;
end;

procedure Move(pX, pY : shortint; T : TTPers; var P : Tpers; var P2 : TPersP2);
var
  nkX, nkY : byte; //  x y,   x y
  vc : shortint;           //  + - 1
  G  : boolean;
  realpY : shortint;

  function pH (XY : shortint) : byte; //  
  begin
    if XY=1 then
    result:=BR_map.Ed_Y
    else
    result:=gravity;
  end;

  function pW (XY : shortint) : byte; //  
  begin
    if P2.Animation=10 then
    case XY of
      -1 : if P2.Animation=10 then      //  
           result:=2
           else
           result:=BR_map.Ed_X div 2;
       0 : result:= BR_map.Ed_X;
       1 : if P2.Animation=10 then     //  
           result:=BR_map.Ed_Y -2
           else
           result:= BR_map.Ed_X + BR_map.Ed_X div 2;
    end
    else
    case XY of
      -1 : result:= BR_map.Ed_X div 2;
       0 : result:= BR_map.Ed_X;
       1 : result:= BR_map.Ed_X + BR_map.Ed_X div 2;
    end;
  end;

  function firepW(XY : shortint) : byte;
  begin
    case XY of
      -1 : result:= 0;
       1 : result:= BR_map.Ed_Y;
    end;
  end;

  procedure Cl_not; //   
  begin
    P2.AnimationPr:=2;
    P2.Animation:=9;
    P2.AnimationN:=T.MofT[9];
    P2.PrV:=-0.5;
    P2.Pr:=true;
  end;

  function LeftToV : shortint;
  begin
    if P2.Left then result:=-1 else result:=1;
  end;

begin
  if P.Y>16*BR_map.Ed_Y then P2.Live:=10
  else
  begin
  kX:= ( P.X+BR_map.Ed_X        )  div BR_map.Ed_X;
  kY:= ( P.Y+BR_Map.Ed_Y        )  div BR_map.Ed_Y;

//  if not KlNoClip(kX, kY) then P2.Live:=10;

  G:=false;
  realpY:=pY;

  if (Map.Kl[kX, kY].T=left) and (pY<>1) and (P.Y<kY*Ed_Y) and (P.Y>kY*Ed_Y-20)
  then       //   
    begin
      P.Y:=kY*Ed_Y-10;
      if (not P2.Pr) and (P2.Animation<>10)
      then
        begin
          if P2.Animation in [11,12] then
          P2.AnimationN:=5
          else
          P2.AnimationN:=1;

          P2.AnimationPr:=10;
          P2.Animation:=9;

          P2.PrV:=0.5;
          P2.Pr:=true;
        end;
    end
  else
    begin
    if (Map.Kl[kX, kY].T=top)       // 
    or ((Map.Kl[kX, kY].T<>top) and (Map.Kl[kX, kY+1].T=top) and (P.Y>(kY)*Ed_Y-10))
     then
      begin
        if (pY<>0) then
        nkY:= round( P.Y+pH(pY) + pY*T.Spd ) div BR_map.Ed_Y;

        if (Map.Kl[kX, kY].T=top) then
          begin
            P2.Animation:=11;
            if pX=0 then
            app(P2.AnimationN, -0.5*pY);
          end
        else
        P2.Animation:=2;

      end
    else
      begin
        if pY<0 then
          begin
            P2.F:=true;
           // if pX=0 then
            P2.Animation:=1;
          end;

        nkY:= round( P.Y+BR_Map.Ed_Y + gravity ) div BR_map.Ed_Y;
        pY:=gravity;      // 
        G:=true;

      end;
    if KlNoClip(kX, nkY) then
      begin
        inc(P.Y, round(pY));    //    
        if (G) and (P2.Animation<>4) and (P2.Animation<>5) then
        if (P2.F) or (P2.Animation=1) then
        P2.Animation:=5
        else
        P2.Animation:=4;
      end
    else
      begin
        P.Y:=kY*Ed_Y-8;

        if realpY>0 then
          begin
            if P2.Animation<>14 then P2.AnimationN:=1;
            P2.Animation:=14;
            if P2.AnimationN<T.MofT[14] then
            app(P2.AnimationN, 0.5);
          end
        else
        case P2.Animation of
          4 : begin
                P2.AnimationN:=1;
                P2.AnimationPr:=2;
                P2.Animation:=6;
                P2.PrV:=0.2;
                P2.Pr:=true;
              end;
          5 : begin
                P2.AnimationN:=1;
                P2.AnimationPr:=1;
                P2.Animation:=7;
                P2.PrV:=0.2;
                P2.Pr:=true;
              end ;
          14 : begin
                P2.AnimationN:=T.MofT[14]-P2.AnimationN+1;
                P2.AnimationPr:=1;
                P2.Animation:=6;
                P2.PrV:=0.2;
                P2.Pr:=true;
              end ;
        end;


        if P2.HG and (not P2.Pr)                 //  Gun
     //   and (Map.Kl[kX+LeftToV, kY+1].T=clip)
     //   and (KlNoClip(kX+LeftToV, kY))
         then
          begin
            P2.AnimationPr:=17;
            P2.Animation:=17;
            P2.AnimationN:=1;
            P2.PrV:=0.25;
            P2.Pr:=true;
           // MapKl[kX+LeftToV, kY+1].ST:=1;

          end;

      end;
  end;

  //   - 
  if (pX<>0) and (not P2.Pr) and (P2.Animation<>14) then
    begin
      nkX:= round( P.X+pW(pX) + pX*T.Spd ) div BR_map.Ed_X;

      if KlNoClip(nkX, kY) then
        begin
          if Map.Kl[kX, kY].T=top then //   
            begin
              app(P2.AnimationN);
              P2.Animation:=12;
              T.Spd:=2;
            end
          else
          if Map.Kl[kX, kY].T=left then //   
            begin
           //   if pY=0 then
              app(P2.AnimationN, pX/2);
              P2.Animation:=10;
              T.Spd:=2;
            end
          else                        //  
          begin
            if P2.Animation=10 then
            Cl_not
            else
              if not (P2.Animation in [4,5,6,7]) then
              begin
                if P2.Shift then
                  begin
                    T.Spd:=T.Spd*2.5; // 
                    P2.Animation:=3;
                    app(P2.AnimationN);
                  end
                else
                  begin
                    P2.Animation:=2;
                    app(P2.AnimationN, 0.75);
                  end;
                P2.F:=false;
              end;
          end;

          inc(P.X, round(pX*T.Spd));       //    

        end;

      case pX of
      -1 : P2.left := true;
       1 : P2.left := false;
      end;

    end;
  // ______
  if P2.Animation=1 then app(P2.AnimationN, 0.1);

  //  
  if P2.Pr then
    begin
      app(P2.AnimationN, P2.PrV);

      if ((P2.PrV<0) and (P2.AnimationN<=1))
      or ((P2.PrV>0) and (P2.AnimationN>=T.MofT[P2.Animation])) then
        begin
          P2.Animation:=P2.AnimationPr;
          P2.Pr:=false;
        end;

      if  (P2.Animation=17) and (P2.AnimationN=4)
      then
        begin
          if P2.Left then pX:=-1 else pX:=1;
          S_Dura.Fire(P.X+firepW(pX), P.Y+T.Gun_pY, T.T_Gun, pX);
        end;
    end
  else   //  
    begin
      if P2.AnimationN>T.MofT[P2.Animation] then P2.AnimationN:=1
      else
      if P2.AnimationN<1 then P2.AnimationN:=T.MofT[P2.Animation];
    end;
   if (not P2.Shift) and (P2.Animation=3) then
   P2.Animation:=2;
   end;


end;

end.
