// Screen.h: interface for the CScreen class.
//
//////////////////////////////////////////////////////////////////////

#include "includes.h"


#if !defined(AFX_SCREEN_H__2D8E0003_9999_4420_942D_513FC08FE14D__INCLUDED_)
#define AFX_SCREEN_H__2D8E0003_9999_4420_942D_513FC08FE14D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScreen  
{
public:
	CScreen();
	virtual ~CScreen();

	int Adapter;		// 0 (NVIDIA GeForce4 Ti 4200)
	int Device;			// 1 (HAL) / 2 (REF)
	int Width, Height;	// 640, 480
	D3DFORMAT Mode;		// 22 (Decktop Window Mode) / 23 (16bit) / 22( 32bit Full Screen Mode)
	bool FullScreen;	
//	D3DFORMAT DepthBufFormat;	// 75 (D3DFMT_D24S8) / D3DFMT_D24X8 / D3DFMT_D16
	int DepthBufCount;			// 2 (Double Depth Buffer) / 3(Triple D.B.)
	int UseTnL;					// 32(OFF) / 64(ON)  / 128(GRAY ON)
	int RefreshRate;			// 0 (Default)

//	LoadFromINI(char *filename);

};

#endif // !defined(AFX_SCREEN_H__2D8E0003_9999_4420_942D_513FC08FE14D__INCLUDED_)
