#include "iofile.h"


void ReadStr(FILE* f, char str_read[255])
{
	if (fgets(str_read, 255, f)==NULL)
		MessageBox(NULL,"End Of File.","ESHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
}

void FindStr(FILE* f, char str_to_find[])
{
	int i,pos;
	char tmpstr[255],*pdest;
	
	do
	{
		ReadStr(f, tmpstr);
		pdest = strchr(tmpstr,str_to_find[0]);
		pos = pdest-tmpstr;
		if( pdest != NULL ){
	
			for(i=0;i<strlen(str_to_find);i++){
				if (tmpstr[pos+i] != str_to_find[i]) break;
			}
			if (i==strlen(str_to_find)) break;
		}
		
	} while ((stricmp(tmpstr,str_to_find))!=0);
}

void BackStr(FILE *f)
{
	char tch;
	//for(int i=0;i<2;i++)
		do{
			fseek(f, -3,SEEK_CUR);
			tch = fgetc(f);
		}while(tch!='\n');
	//fseek(f, 3,SEEK_CUR);
}

void FindStrAndBack(FILE* f, char str_to_find[]){
	FindStr(f, str_to_find);
	BackStr(f);
}


int ReadIntBin(FILE* f){
	int num;
	unsigned char ch,ch2;
	ch = fgetc(f);
	ch2 = fgetc(f);
	if (ch==0){
		num = ch2;
	} else {
		num = ch*256+ch2;
	}
	return num;
}

float ReadFloatBin(FILE* f){
	float num;
	int i,m;
	char ch;
	
	ch = fgetc(f);
	i = ReadIntBin(f);
	m = ReadIntBin(f);
	num =(float) i+((float)m/10000.0f);
	if (ch == '-') num = -num;
	return num;
}


void ReadString(FILE *f, char str_read[255])
{
	char ch,stmp[255];
	int i = 0;
	
	ch = fgetc(f);
	do{
		ch = fgetc(f);
		stmp[i] = ch;
		i++;
	}while(ch!='"');
	stmp[i-1] = '\0';

	//str_read = "texture.tex";//stmp-1;
	sprintf(str_read,"%s",stmp);
}

void ReadComment(FILE* f)
{
	char ch;
	do{
		ch = fgetc(f);
	}while(ch!='>');
}
