program Shinigami;

uses
  Windows,
  HGE,
  g_Types in 'gameengine\g_Types.pas',
  g_main in 'gameengine\g_main.pas',
  g_game in 'gameengine\g_game.pas',
  g_menu in 'gameengine\g_menu.pas',
  g_Utils in 'gameengine\g_Utils.pas',
  g_Intro in 'gameengine\g_Intro.pas',
  g_Loading in 'gameengine\g_Loading.pas',
  g_options in 'gameengine\g_options.pas',
  g_math in 'gameengine\g_math.pas',
  g_hint in 'gameengine\g_hint.pas',
  g_LevelManager in 'gameengine\g_LevelManager.pas',
  g_pchar in 'gameengine\g_pchar.pas',
  g_gui in 'gameengine\g_gui.pas',
  g_map in 'gameengine\g_map.pas',
  g_cfg in 'gameengine\g_cfg.pas',
  g_camera in 'gameengine\g_camera.pas',
  g_bonus in 'gameengine\g_bonus.pas',
  g_about in 'gameengine\g_about.pas',
  g_TOP in 'gameengine\g_TOP.pas',
  g_Profile in 'gameengine\g_Profile.pas',
  g_language in 'gameengine\g_language.pas',
  g_Online_Top in 'gameengine\g_Online_Top.pas',
  g_player in 'gameengine\g_player.pas',
  g_Gun_mini in 'gameengine\g_Gun_mini.pas',
  g_gun_rocket in 'gameengine\g_gun_rocket.pas',
  g_gun_voice in 'gameengine\g_gun_voice.pas',
  g_particle_manager in 'gameengine\g_particle_manager.pas',
  g_monster_fly in 'gameengine\g_monster_fly.pas',
  g_monster_eye in 'gameengine\g_monster_eye.pas',
  g_monster_nlo in 'gameengine\g_monster_nlo.pas',
  g_boss_BigHead in 'gameengine\g_boss_BigHead.pas',
  g_monster_bee in 'gameengine\g_monster_bee.pas';

{$R icon.res}
begin
   randomize;
  //ReportMemoryLeaksOnShutdown := True;
  _HGE := HGECreate(HGE_VERSION);

  _HGE.System_SetState(HGE_INIFILE,'config.ini');
  _HGE.System_SetState(HGE_LOGFILE,GAME_NAME+'.log');
  _HGE.System_SetState(HGE_TITLE,GAME_TITLE);
  _HGE.System_SetState(HGE_FRAMEFUNC,MainUpdate);
  _HGE.System_SetState(HGE_RENDERFUNC,MainDraw);
  _HGE.System_SetState(HGE_SHOWSPLASH,false);
  _HGE.System_SetState(HGE_FOCUSLOSTFUNC,FocusLost);
  _HGE.System_SetState(HGE_FOCUSGAINFUNC,FocusReturn);
  _HGE.System_SetState(HGE_ICON,'Icon icon.bmp');

  Options := TOptions.Create;
  Options.Load;
  Language := TLanguage.Create;
  _HGE.System_SetState(HGE_WINDOWED,not Options.FullScreen);
  _HGE.System_SetState(HGE_SCREENWIDTH, Options.WinWidth);
	_HGE.System_SetState(HGE_SCREENHEIGHT, Options.WinHeight);
	_HGE.System_SetState(HGE_SCREENBPP, Options.BitDepth);
  if Options.vSync=1 then
    _HGE.System_SetState(HGE_FPS,HGEFPS_VSYNC);
  _HGE.System_SetState(HGE_USESOUND,true);

  if (_HGE.System_Initiate) then begin
    StartIntro;
    _HGE.System_Start;
    MainDestroy;
  end else begin
    MessageBox(0,PChar(_HGE.System_GetErrorMessage),'Error',
      MB_OK or MB_ICONERROR or MB_APPLMODAL);
  end;
  _HGE.System_Shutdown;
  _HGE := nil;
end.

