unit BR_ai;    //  ,     

interface

uses
  Omega, BR_materials;

type
  TTpers = record                 // 
    CRun, CClimb,                 //  , ,
    CFire, CUp : boolean;         //  ,   
    Spd  : single;                // 
    MofT : array[1..20] of byte;  //  
    Gun_pY, T_Gun : byte;         //     
                                  //  
  end;

  TpersP2 = record
    Animation, AnimationPr,             // ,   ,
    AnimationT, Live        : byte;     //  
    AnimationN, PrV         : single;   //   , + -
    Pr, Left, Shift, F, HG  : boolean   //   ,
                                        // , , , HoleGun
  end;

var
  BotP2  : array of TpersP2;
  BotT   : array[1..2] of TTPers;

procedure Draw;
procedure Work;

implementation

uses
   BR_map, BR_game, S_Dura, LexUtils, Live;

procedure Work;
var
  I, pY, pX : integer;

  function firepW(XY : shortint) : byte;
  begin
    case XY of
      -1 : result:= 0;
       1 : result:= BR_map.Ed_Y;
    end;
  end;

  function ISeeHero : boolean;
  begin
    if  (   ((BotP2[I].Left)     and (Map.Hero.X>Map.Bot[I].X-700) and (Map.Hero.X<Map.Bot[I].X+350))
         or ((not BotP2[I].Left) and (Map.Hero.X>Map.Bot[I].X-250) and (Map.Hero.X<Map.Bot[I].X+600)))
    and (Map.Hero.Y>Map.Bot[I].Y-300) and (Map.Hero.Y<Map.Bot[I].Y+700)
    then
      result:=true
    else
      result:=false;
  end;

begin
  for I:=0 to Map.MofBot-1 do
  if BotP2[I].Live>1 then
    begin
     pY:=0;
      if (BotP2[I].Live>10) and (ISeeHero) then  //   
        begin
          if Map.Hero.X<Map.Bot[I].X then BotP2[I].Left:=true else BotP2[I].Left:=false;
          if Map.Bot[I].Y = Live.kY*BR_map.Ed_Y then
            begin
              if (BotP2[I].Animation<4)
              or (BotP2[I].AnimationN>=BotT[1].MofT[BotP2[I].Animation]) then
                 begin
                   BotP2[I].Animation:=5;
                   BotP2[I].AnimationN:=1;
                 end;
            end
          else
          if Map.Bot[I].Y < Live.kY*BR_map.Ed_Y then
            pY:=1 else pY:=-1;
        end;
      // _____
      if BotP2[I].Animation=6 then pY:=2;
      Map.Bot[I].Y:=round(Map.Bot[I].Y+pY*BotT[1].Spd);

      if (BotP2[I].Live<=10) and
      (Map.Kl[(Map.Bot[I].X+BR_map.Ed_X) div BR_map.Ed_X-1,
              (Map.Bot[I].Y+BR_Map.Ed_Y+64) div BR_map.Ed_Y-1].T in [clip, clip2]) then
      BotP2[I].Live:=1;

      BotP2[I].PrV:=0.2;

      if  (BotP2[I].Animation=5) and (BotP2[I].AnimationN>4) and (BotP2[I].AnimationN<4.2)
      then
        begin
          if BotP2[I].Left then pX:=-1 else pX:=1;
          S_Dura.Fire(Map.Bot[I].X+firepW(pX), Map.Bot[I].Y+BotT[1].Gun_pY, 1, pX);
        end;

      if BotP2[I].Animation<4 then
        case pY of
          -1 : BotP2[I].Animation:=3;
           0 : BotP2[I].Animation:=1;
           1 : BotP2[I].Animation:=2;
        end
//     else

      else
      if BotP2[I].Animation<>6 then
      if  (BotP2[I].AnimationN>=BotT[1].MofT[BotP2[I].Animation]-1) then
        begin
          BotP2[I].Animation:=1;
          BotP2[I].AnimationN:=1;
        end;
      
      app(BotP2[I].AnimationN, BotP2[I].PrV);
      if BotP2[I].AnimationN>BotT[1].MofT[BotP2[I].Animation] then BotP2[I].AnimationN:=1
      else
      if BotP2[I].AnimationN<1 then BotP2[I].AnimationN:=BotT[1].MofT[BotP2[I].Animation];
    end;
end;

procedure Draw;
var
  Flag,
  I : integer;
begin
 // if  Map.MofBot>0 then
  for I:=0 to Map.MofBot-1 do
    begin
      if BotP2[I].Left then Flag:=FX_DEFAULT or FX_FLIPX
      else Flag:=1;
      if Map.Hero.T>0 then
      Omega.ASprite_Draw(TBot[BotP2[I].Animation], Map.Bot[I].X-CameraX, Map.Bot[I].Y-CameraY,
                         128, 64, round(BotP2[I].AnimationN), 255, 0, Flag);
     
    end;
end;


end.
